/********************************************************************
 * Copyright (C) Microsoft Corporation.								*
 * libcmt rewritten by SK											*
 * Copyright (c) 2011-12 by SK karoly.saly@matrasoft.hu				*
 *																	*
 * libcmt - wwincrt0.c												*
 * startup routine for Windows apps (UNICODE)						*
 ********************************************************************/
#undef _UNICODE
#undef UNICODE

#define _UNICODE 1
#define UNICODE 1

#include "crtdefs.h"
#include "crtplus.h"
#include "libcmt.h"

INT32 __stdcall wWinMainX(LPWSTR lpCmdLine, INT32 nCmdShow);

extern IMAGE_DOS_HEADER		__ImageBase;

// These routines do the C runtime initialization, call the appropriate user entry function, and handle termination cleanup.
// For a managed app, they then return the exit code back to the calling routine, which is the managed startup code.
// For an unmanaged app, they call exit and never return.
// User entry called: wWinMain

static int __tmainCRTStartup(void);

int wWinMainCRTStartup(void) {
// The /GS security cookie must be initialized before any exception handling targetting the current image is registered.
// No function using exception handling can be called in the current image until after __security_init_cookie has been called.

	__security_init_cookie();
	return __tmainCRTStartup();
}

__declspec(noinline) int __tmainCRTStartup(void) {
STARTUPINFOW	StartupInfo;
LPWSTR			pCmdLine;
int				nRet;

	g_hInstance = g_hResource = (HINSTANCE) &__ImageBase;
	g_nCpuFeatures = GetCpuFeatures(TRUE);
	GetWinVersion(&g_sWinVersion);
	_crtInitProgNameW();
	_crtExeInit();
	nRet = _crtCommonInit(APP_GUI);
	if (nRet == 0) {
		__try {
			GetStartupInfoW(&StartupInfo);
			pCmdLine = _crtGetCmdLineW();
			nRet = wWinMainX(pCmdLine, StartupInfo.dwFlags & STARTF_USESHOWWINDOW ? StartupInfo.wShowWindow : SW_SHOWDEFAULT);
        }
		__except(EXCEPTION_EXECUTE_HANDLER) {
			nRet = GetExceptionCode();					// Should never reach here
		} // end of try - except
	}
	exit(nRet);
	return nRet;
}
